/*
 Copyright (C) 2013 Stefano Zanotti.

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SAFE_STRING_H_
#define SAFE_STRING_H_

#include <string.h>

inline
char* strcpy_s(char* dst, const char* src, size_t maxChars){
    *dst = '\0';
    return strncat(dst, src, maxChars);
}

inline
char* strcpy_sP(char* dst, const char* /*PROGMEM*/ src, size_t maxChars) {
    for(size_t i = 0; i < maxChars; i++) {
        char c = pgm_read_byte(src + i);
        dst[i] = c;
        
        if(!c) {
            return dst + i;
        }
    }
    return dst;
}

class __FlashStringHelper;

inline
char* strcpy_sP(char* dst, const __FlashStringHelper* src, size_t maxChars) {
    return strcpy_sP(dst, (const char /*PROGMEM*/ *) src, maxChars);
}

#endif /* SAFE_STRING_H_ */