/*
 Copyright (C) 2013 Stefano Zanotti.

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UTILS_H_
#define UTILS_H_

#ifdef min
    #undef min
#endif

#ifdef max
    #undef max
#endif

#ifdef abs
    #undef abs
#endif

template<typename T>
inline
const T& min(const T& a, const T& b) {
    return (b < a) ? b : a;
}

template<typename T>
inline
const T& max(const T& a, const T& b) {
    return (a < b) ? b : a;
}

template<typename T>
inline
void swap(T& a, T& b) {
    T tmp = a;
    a = b;
    b = tmp;
}

template<typename T>
inline
T abs(const T& a) {
    return a < T(0) ? -a : a;
}


#endif /* UTILS_H_ */